Name:           perl-forks
Version:        0.33
Release:        3%{?dist}
Summary:        A drop-in replacement for Perl threads using fork()

Group:          Development/Libraries
License:        (GPL+ or Artistic) and (GPLv2+ or Artistic)
URL:            http://search.cpan.org/~rybskej/%{name}-%{version}/
Source0:        http://search.cpan.org/CPAN/authors/id/R/RY/RYBSKEJ/forks-%{version}.tar.gz
# https://bugzilla.novell.com/show_bug.cgi?id=527537
# https://bugzillafiles.novell.org/attachment.cgi?id=313860
# http://rt.cpan.org/Public/Bug/Display.html?id=49878
Patch0:         perl-forks-assertion.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  perl(ExtUtils::MakeMaker), perl(List::MoreUtils)
BuildRequires:  perl(Sys::SigAction) >= 0.11, perl(Acme::Damn)
BuildRequires:  perl(Devel::Symdump), perl(Test::More)
Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

# This provides is not getting picked up
Provides:       perl(forks::Devel::Symdump) = %{version}

%description
The forks.pm module is a drop-in replacement for threads.pm.  It has the
same syntax as the threads.pm module (it even takes over its namespace) but
has some significant differences:

- you do _not_ need a special (threaded) version of Perl
- it is _much_ more economic with memory usage on OS's that support COW
- it is more efficient in the startup of threads
- it is slightly less efficient in the stopping of threads
- it is less efficient in inter-thread communication

If for nothing else, it allows you to use the Perl threading model in
non-threaded Perl builds and in older versions of Perl (5.6.0 and
higher are supported).


%prep
%setup -q -n forks-%{version}

# see comments above for origin and upstream bug report
%if 0%{fedora} < 13
%patch0 -p1 -b .perl-forks-assertion
%endif


%build
find . -type f -print | xargs chmod a-x
%{__perl} Makefile.PL INSTALLDIRS=vendor OPTIMIZE="$RPM_OPT_FLAGS"
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
find $RPM_BUILD_ROOT -depth -type d -exec rmdir {} 2>/dev/null ';'
chmod -R u+w $RPM_BUILD_ROOT/*


%check
make test


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc CHANGELOG CREDITS README TODO
%{perl_vendorarch}/*
%exclude %dir %{perl_vendorarch}/auto/
%{_mandir}/man3/*.3*


%changelog
* Sun Jan 31 2010 Bernard Johnson <bjohnson@symetrix.com> - 0.33-3
- fix permissions in build to squelch rpmlint complaints
- add version to provides

* Tue Jan 19 2010 Bernard Johnson <bjohnson@symetrix.com> - 0.33-2
- fix BR
- add patch from novell site to fix assertion in fedora < 13
- change references of forks::Devel::Symdump to Devel::Symdump

* Fri Jun 06 2009 Bernard Johnson <bjohnson@symetrix.com> - 0.33-1
- initial release
